// IL_P2P_CO.ls
// VER:2.0.0 / 2002101901 / beta
// (c) Reiner Schug

@version 2.5
@script custom
@name Parent2Point_CO

@define ERR_CRITICAL "Critical error! No particles found. Please re-add all P2Pnt scripts in correct order."

part;
partObj=nil;
partObjName="";
firstCall=true;
criticalError=false;

create: id
{
	setdesc("Parent2Point_CO");
	partObjName=id.name;
}


process: ca
{
	if(firstCall)
	{
		// wait for object during sceneload
		initParticles();
		firstCall=false;
		return;
	}

	if(part && !criticalError)
	{
		return if(part[1].count < 1);
		// draw information for each particle
		for(i=1; i <= part[1].count; i++)
		{
			ppos=part[1].getParticle(i, PART_POSITION);
			ca.setColor(<0,0,0>);
			ca.drawText(ppos+<0,.05,0>, string(i), SYS_WORLD, CENTER);
			ca.setColor(<1,0,0>);
			ca.drawText(ppos, "V", SYS_WORLD, CENTER);
		}
	}
}

options
{
	RefreshNow();
}

initParticles
{
	criticalError=true;
	if(!partObjName) return false; 

	partObj=Mesh(partObjName);
	if(!partObj) return false;

	part=Particle(partObj) || error(ERR_CRITICAL); //careful: crash if no particle instance exists
	if(!part) return false;
	if( part.size() != 1  ) return false;
	if(partNum<1 || partNum>part[1].count) return false;
	criticalError=false;
	return true;
}
