// IL_P2P_DM.ls
// VER:2.0.0 / 2002101901 / beta
// (c) Reiner Schug

@version 2.5
@script displace
@name Parent2Point_DM

@define VM_NAME_PT "p2p_tag"

obj;
part, partIDX, partVMap;
curPoint, totalPoints, pointIDX;
pIDX;

create: id
{
	setdesc("Parent2Point_DM");
	obj=Mesh(id.name);

	// initialize this particle instance
    part = Particle("particle", @"position", "mass"@);
    part.attach(id);
	totalPoints=obj.pointCount();
	curPoint=totalPoints+1;
	pIDX=0;	
	createParticles();
	setdesc("Parent2Point_DM");	
}

destroy
{
	part.reset();
	part.detach(obj);
}

newtime: id, frame, time
{
	if(pIDX<1)
		curPoint=totalPoints+1;
	else
		curPoint=0;
	partIDX=1;
}

flags { return(WORLD); }

process: da
{
	return if(obj.visibility==VIS_HIDDEN);
	
	curPoint++;

	/*
	if(curPoint>totalPoints)
	{
		partIDX=1;
		curPoint=1;
	}
	*/

	if(curPoint > totalPoints)
		return;

	if(curPoint == pointIDX[partIDX])
	{
		// move this particle to displaced position
		part.setParticle(partIDX, "position", <da.source[1], da.source[2], da.source[3]>);
		partIDX++;
	}
}
 
options
{
	//info( obj.position(obj.vertex(obj.polygons[1], 1)) );
	createParticles();

	vmsize=size(pointIDX);
	if(vmsize < 1)
		error("no points in VMap");
	else
		info(string(vmsize, " particles created"));
	
	RefreshNow();
}


createParticles
{
	partVMap=VMap(VMWEIGHT);
	while(partVMap && partVMap.name != VM_NAME_PT)
		partVMap=partVMap.next();

	if(partVMap==nil) 
	{
		warn(string(VM_NAME_PT, " not found in ", obj.name)); 
		curPoint=obj.pointCount() + 1;
		return; 
	}


	if(partVMap.name != VM_NAME_PT)
		return;

	totalPoints=obj.pointCount();

	pointIDX=nil;
	part.reset();

	pIDX=1;

	for(p=1; p <= totalPoints; p++)
	{
		if( partVMap.isMapped(obj.points[p]) )
		{
			pointIDX[pIDX++]=p;
			partIDX = part.addParticle();
				part.setParticle(partIDX, "mass", partVMap.getValue(obj.points[p], 1));
		}
	}
	pointIDX[pIDX]=0; 
}
